package pl.net.mamut.jsf.let;

import java.io.IOException;

import javax.faces.component.UIComponentBase;
import javax.faces.context.FacesContext;

/**
 * @author Adam Warski (adam at warski dot org)
 */
public class UILet extends UIComponentBase {
    public String getFamily() {
        return "pl.net.mamut.jsf.Let";
    }

    @SuppressWarnings({"unchecked"})
	@Override
    public void encodeBegin(FacesContext context) throws IOException {
        String var = (String) getAttributes().get("var");
        Object value = getAttributes().get("value");

        context.getExternalContext().getRequestMap().put(var, value);
    }

	@Override
    public void encodeEnd(FacesContext context) throws IOException {
        String var = (String) getAttributes().get("var");

        context.getExternalContext().getRequestMap().remove(var);
    }

	@Override
	public void processDecodes(FacesContext context) {
		String var = (String) getAttributes().get("var");
        Object value = getAttributes().get("value");

        context.getExternalContext().getRequestMap().put(var, value);

		super.processDecodes(context);

		context.getExternalContext().getRequestMap().remove(var);
	}
}
